Panda3D

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
EggMaterial Class Reference
Inheritance diagram for EggMaterial:

## Public Types
enum | Equivalence { E_attributes = 0x001 , E_mref_name = 0x002 }

## Public Member Functions
| EggMaterial (const EggMaterial &copy)
| EggMaterial (const std::string &mref_name)
void | clear_amb ()
void | clear_base ()
void | clear_diff ()
void | clear_emit ()
void | clear_ior ()
void | clear_local ()
void | clear_metallic ()
void | clear_roughness ()
void | clear_shininess ()
void | clear_spec ()
virtual TypeHandle | force_init_type ()
LColor | get_amb () const
LColor | get_base () const
LColor | get_diff () const
LColor | get_emit () const
double | get_ior () const
bool | get_local () const
double | get_metallic () const
double | get_roughness () const
double | get_shininess () const
LColor | get_spec () const
virtual TypeHandle | get_type () const
bool | has_amb () const
bool | has_base () const
bool | has_diff () const
bool | has_emit () const
bool | has_ior () const
bool | has_local () const
bool | has_metallic () const
bool | has_roughness () const
bool | has_shininess () const
bool | has_spec () const
bool | is_equivalent_to (const EggMaterial &other, int eq) const
| Returns true if the two materials are equivalent in all relevant properties (according to eq), false otherwise.
void | set_amb (const LColor &amb)
void | set_base (const LColor &base)
void | set_diff (const LColor &diff)
void | set_emit (const LColor &emit)
void | set_ior (double ior)
void | set_local (bool local)
void | set_metallic (double metallic)
void | set_roughness (double roughness)
void | set_shininess (double shininess)
void | set_spec (const LColor &spec)
bool | sorts_less_than (const EggMaterial &other, int eq) const
| An ordering operator to compare two materials for sorting order.
virtual void | write (std::ostream &out, int indent_level) const
| Writes the material definition to the indicated output stream in Egg format.
Public Member Functions inherited from EggNode
| EggNode (const EggNode &copy)
| EggNode (const std::string &name="")
void | apply_texmats ()
| Applies the texture matrices to the UV's of the vertices that reference them, and then removes the texture matrices from the textures themselves.
virtual EggRenderMode * | determine_alpha_mode ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has an alpha_mode other than AM_unspecified.
virtual EggRenderMode * | determine_bin ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a bin specified.
virtual bool | determine_decal ()
| Walks back up the hierarchy, looking for an EggGroup at this level or above that has the "decal" flag set.
virtual EggRenderMode * | determine_depth_offset ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a depth_offset specified.
virtual EggRenderMode * | determine_depth_test_mode ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a depth_test_mode other than DTM_unspecified.
virtual EggRenderMode * | determine_depth_write_mode ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a depth_write_mode other than DWM_unspecified.
virtual EggRenderMode * | determine_draw_order ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a draw_order specified.
virtual bool | determine_indexed ()
| Walks back up the hierarchy, looking for an EggGroup at this level or above that has the "indexed" scalar set.
virtual EggRenderMode * | determine_visibility_mode ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a visibility_mode other than VM_unspecified.
void | flatten_transforms ()
| Removes any transform and instance records from this node in the scene graph and below.
int | get_depth () const
const LMatrix4d & | get_node_frame () const
| Returns the coordinate frame of the node itself.
const LMatrix4d & | get_node_frame_inv () const
| Returns the inverse of the matrix returned by get_node_frame().
const LMatrix4d * | get_node_frame_inv_ptr () const
| Returns either a NULL pointer or a unique pointer shared by nodes with the same get_node_frame_inv() matrix.
const LMatrix4d * | get_node_frame_ptr () const
| Returns either a NULL pointer or a unique pointer shared by nodes with the same get_node_frame() matrix.
const LMatrix4d & | get_node_to_vertex () const
| Returns the transformation matrix suitable for converting vertices in the coordinate space of the node to the appropriate coordinate space for storing in the egg file.
const LMatrix4d * | get_node_to_vertex_ptr () const
| Returns either a NULL pointer or a unique pointer shared by nodes with the same get_node_to_vertex() matrix.
EggGroupNode * | get_parent () const
const LMatrix4d & | get_vertex_frame () const
| Returns the coordinate frame of the vertices referenced by primitives at or under this node.
const LMatrix4d & | get_vertex_frame_inv () const
| Returns the inverse of the matrix returned by get_vertex_frame().
const LMatrix4d * | get_vertex_frame_inv_ptr () const
| Returns either a NULL pointer or a unique pointer shared by nodes with the same get_vertex_frame_inv() matrix.
const LMatrix4d * | get_vertex_frame_ptr () const
| Returns either a NULL pointer or a unique pointer shared by nodes with the same get_vertex_frame() matrix.
const LMatrix4d & | get_vertex_to_node () const
| Returns the transformation matrix suitable for converting the vertices as read from the egg file into the coordinate space of the node.
const LMatrix4d * | get_vertex_to_node_ptr () const
| Returns either a NULL pointer or a unique pointer shared by nodes with the same get_vertex_to_node() matrix.
virtual bool | is_anim_matrix () const
| Returns true if this node represents a table of animation transformation data, false otherwise.
virtual bool | is_joint () const
| Returns true if this particular node represents a <Joint> entry or not.
bool | is_local_coord () const
| Returns true if this node's vertices are not in the global coordinate space.
bool | is_under_instance () const
| Returns true if there is an <Instance> node somewhere in the egg tree at or above this node, false otherwise.
bool | is_under_transform () const
| Returns true if there is a <Transform> entry somewhere in the egg tree at or above this node, false otherwise.
EggNode & | operator= (const EggNode &copy)
bool | parse_egg (const std::string &egg_syntax)
| Parses the egg syntax given in the indicate string as if it had been read from the egg file within this object's definition.
int | rename_node (vector_string strip_prefix)
| Rename by stripping out the prefix.
void | test_under_integrity () const
void | transform (const LMatrix4d &mat)
| Applies the indicated transformation to the node and all of its descendants.
void | transform_vertices_only (const LMatrix4d &mat)
| Applies the indicated transformation only to vertices that appear in global space within vertex pools at this node and below.
Public Member Functions inherited from EggNamedObject
| EggNamedObject (const EggNamedObject &copy)
| EggNamedObject (const std::string &name="")
EggNamedObject & | operator= (const EggNamedObject &copy)
void | output (std::ostream &out) const
void | write_header (std::ostream &out, int indent_level, const char *egg_keyword) const
| Writes the first line of the egg object, e.g.
Public Member Functions inherited from EggObject
| EggObject (const EggObject &copy)
virtual EggTransform * | as_transform ()
| Returns this object cross-cast to an EggTransform pointer, if it inherits from EggTransform, or NULL if it does not.
void | clear_user_data ()
| Removes *all* user data pointers from the node.
void | clear_user_data (TypeHandle type)
| Removes the user data pointer of the indicated type.
EggUserData * | get_user_data () const
| Returns the user data pointer most recently stored on this object, or NULL if nothing was previously stored.
EggUserData * | get_user_data (TypeHandle type) const
| Returns the user data pointer of the indicated type, if it exists, or NULL if it does not.
bool | has_user_data () const
| Returns true if a generic user data pointer has recently been set and not yet cleared, false otherwise.
bool | has_user_data (TypeHandle type) const
| Returns true if the user data pointer of the indicated type has been set, false otherwise.
EggObject & | operator= (const EggObject &copy)
void | set_user_data (EggUserData *user_data)
| Sets the user data associated with this object.
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from Namable
| Namable (const std::string &initial_name="")
void | clear_name ()
| Resets the Namable's name to empty.
const std::string & | get_name () const
bool | has_name () const
| Returns true if the Namable has a nonempty name set, false if the name is empty.
void | output (std::ostream &out) const
| Outputs the Namable.
void | set_name (const std::string &name)

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from EggNode
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from EggNamedObject
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from EggObject
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from Namable
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
| clear_amb
| clear_base
| clear_diff
| clear_emit
| clear_ior
| clear_local
| clear_metallic
| clear_roughness
| clear_shininess
| clear_spec
| get_amb
| It is legal to call this even if has_amb() returns false.
| get_base
| It is legal to call this even if has_base() returns false.
| get_diff
| It is legal to call this even if has_diff() returns false.
| get_emit
| It is legal to call this even if has_emit() returns false.
| get_ior
| get_local
| get_metallic
| get_roughness
| get_shininess
| get_spec
| It is legal to call this even if has_spec() returns false.
| has_amb
| has_base
| has_diff
| has_emit
| has_ior
| has_local
| has_metallic
| has_roughness
| has_shininess
| has_spec
| set_amb
| set_base
| set_diff
| set_emit
| set_ior
| set_local
| set_metallic
| set_roughness
| set_shininess
| set_spec
Public Attributes inherited from EggNode
| get_depth
| Returns the number of nodes above this node in the egg hierarchy.
| get_parent
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.
Public Attributes inherited from Namable
| get_name
| set_name

## Detailed Description

Definition at line 26 of file eggMaterial.h.

## Member Enumeration Documentation

## ◆ Equivalence

enum EggMaterial::Equivalence

Definition at line 33 of file eggMaterial.h.

## Constructor & Destructor Documentation

## ◆ EggMaterial() [1/2]

EggMaterial::EggMaterial | ( | const std::string & | mref_name | ) |
| explicit

Definition at line 24 of file eggMaterial.cxx.

## ◆ EggMaterial() [2/2]

EggMaterial::EggMaterial | ( | const EggMaterial & | copy | ) |

Definition at line 34 of file eggMaterial.cxx.

## Member Function Documentation

## ◆ force_init_type()

virtual TypeHandle EggMaterial::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from EggNode.

Definition at line 143 of file eggMaterial.h.

## ◆ get_class_type()

static TypeHandle EggMaterial::get_class_type | ( |  | ) |
| inline static

Definition at line 132 of file eggMaterial.h.

## ◆ get_type()

virtual TypeHandle EggMaterial::get_type | ( |  | ) | const
| inline virtual

Reimplemented from EggNode.

Definition at line 140 of file eggMaterial.h.

## ◆ init_type()

static void EggMaterial::init_type | ( |  | ) |
| inline static

Definition at line 135 of file eggMaterial.h.

## ◆ is_equivalent_to()

bool EggMaterial::is_equivalent_to | ( | const EggMaterial & | other,
|  | int | eq ) const

Returns true if the two materials are equivalent in all relevant properties (according to eq), false otherwise.

The Equivalence parameter, eq, should be set to the bitwise OR of the following properties, according to what you consider relevant:

EggMaterial::E_attributes: All material attributes (diff, spec, etc.) except MRef name.

EggMaterial::E_mref_name: The MRef name.

Definition at line 165 of file eggMaterial.cxx.

References get_amb, get_base, get_diff, get_emit, get_ior, get_metallic, get_roughness, get_spec, has_base, has_ior, has_metallic, and has_roughness.

Referenced by EggMaterialCollection::create_unique_material().

## ◆ sorts_less_than()

bool EggMaterial::sorts_less_than | ( | const EggMaterial & | other,
|  | int | eq ) const

An ordering operator to compare two materials for sorting order.

This imposes an arbitrary ordering useful to identify unique materials, according to the indicated Equivalence factor. See is_equivalent_to().

Definition at line 197 of file eggMaterial.cxx.

References get_amb, get_diff, get_emit, get_ior, get_metallic, get_roughness, get_spec, has_ior, has_metallic, and has_roughness.

## ◆ write()

void EggMaterial::write | ( | std::ostream & | out,
|  | int | indent_level ) const
| virtual

Writes the material definition to the indicated output stream in Egg format.

Implements EggNode.

Definition at line 56 of file eggMaterial.cxx.

References get_amb, get_base, get_diff, get_emit, get_ior, get_metallic, get_roughness, get_spec, has_base, has_ior, has_metallic, has_roughness, indent(), and EggNamedObject::write_header().

## Member Data Documentation

## ◆ clear_amb

void EggMaterial::clear_amb
| inline

Definition at line 94 of file eggMaterial.h.

## ◆ clear_base

void EggMaterial::clear_base
| inline

Since
  1.10.0

Definition at line 92 of file eggMaterial.h.

## ◆ clear_diff

void EggMaterial::clear_diff
| inline

Definition at line 93 of file eggMaterial.h.

## ◆ clear_emit

void EggMaterial::clear_emit
| inline

Definition at line 95 of file eggMaterial.h.

## ◆ clear_ior

void EggMaterial::clear_ior
| inline

Since
  1.10.0

Definition at line 100 of file eggMaterial.h.

## ◆ clear_local

void EggMaterial::clear_local
| inline

Definition at line 102 of file eggMaterial.h.

## ◆ clear_metallic

void EggMaterial::clear_metallic
| inline

Since
  1.10.0

Definition at line 99 of file eggMaterial.h.

## ◆ clear_roughness

void EggMaterial::clear_roughness
| inline

Since
  1.10.0

Definition at line 98 of file eggMaterial.h.

## ◆ clear_shininess

void EggMaterial::clear_shininess
| inline

Definition at line 97 of file eggMaterial.h.

## ◆ clear_spec

void EggMaterial::clear_spec
| inline

Definition at line 96 of file eggMaterial.h.

## ◆ get_amb

LColor EggMaterial::get_amb
| inline

It is legal to call this even if has_amb() returns false.

If so, it simply returns the default amb color.

Definition at line 94 of file eggMaterial.h.

Referenced by is_equivalent_to(), sorts_less_than(), and write().

## ◆ get_base

LColor EggMaterial::get_base
| inline

It is legal to call this even if has_base() returns false.

If so, it simply returns the default base color.

Since
  1.10.0

Definition at line 92 of file eggMaterial.h.

Referenced by is_equivalent_to(), and write().

## ◆ get_diff

LColor EggMaterial::get_diff
| inline

It is legal to call this even if has_diff() returns false.

If so, it simply returns the default diff color.

Definition at line 93 of file eggMaterial.h.

Referenced by is_equivalent_to(), XFileMaterial::set_from_egg(), sorts_less_than(), and write().

## ◆ get_emit

LColor EggMaterial::get_emit
| inline

It is legal to call this even if has_emit() returns false.

If so, it simply returns the default emit color.

Definition at line 95 of file eggMaterial.h.

Referenced by is_equivalent_to(), XFileMaterial::set_from_egg(), sorts_less_than(), and write().

## ◆ get_ior

double EggMaterial::get_ior
| inline

Since
  1.10.0

Definition at line 100 of file eggMaterial.h.

Referenced by is_equivalent_to(), sorts_less_than(), and write().

## ◆ get_local

bool EggMaterial::get_local
| inline

Definition at line 102 of file eggMaterial.h.

## ◆ get_metallic

double EggMaterial::get_metallic
| inline

Since
  1.10.0

Definition at line 99 of file eggMaterial.h.

Referenced by is_equivalent_to(), sorts_less_than(), and write().

## ◆ get_roughness

double EggMaterial::get_roughness
| inline

Since
  1.10.0

Definition at line 98 of file eggMaterial.h.

Referenced by is_equivalent_to(), sorts_less_than(), and write().

## ◆ get_shininess

double EggMaterial::get_shininess
| inline

Definition at line 97 of file eggMaterial.h.

## ◆ get_spec

LColor EggMaterial::get_spec
| inline

It is legal to call this even if has_spec() returns false.

If so, it simply returns the default spec color.

Definition at line 96 of file eggMaterial.h.

Referenced by is_equivalent_to(), XFileMaterial::set_from_egg(), sorts_less_than(), and write().

## ◆ has_amb

bool EggMaterial::has_amb
| inline

Definition at line 94 of file eggMaterial.h.

## ◆ has_base

bool EggMaterial::has_base
| inline

Since
  1.10.0

Definition at line 92 of file eggMaterial.h.

Referenced by is_equivalent_to(), and write().

## ◆ has_diff

bool EggMaterial::has_diff
| inline

Definition at line 93 of file eggMaterial.h.

## ◆ has_emit

bool EggMaterial::has_emit
| inline

Definition at line 95 of file eggMaterial.h.

## ◆ has_ior

bool EggMaterial::has_ior
| inline

Since
  1.10.0

Definition at line 100 of file eggMaterial.h.

Referenced by is_equivalent_to(), sorts_less_than(), and write().

## ◆ has_local

bool EggMaterial::has_local
| inline

Definition at line 102 of file eggMaterial.h.

## ◆ has_metallic

bool EggMaterial::has_metallic
| inline

Since
  1.10.0

Definition at line 99 of file eggMaterial.h.

Referenced by is_equivalent_to(), sorts_less_than(), and write().

## ◆ has_roughness

bool EggMaterial::has_roughness
| inline

Since
  1.10.0

Definition at line 98 of file eggMaterial.h.

Referenced by is_equivalent_to(), sorts_less_than(), and write().

## ◆ has_shininess

bool EggMaterial::has_shininess
| inline

Definition at line 97 of file eggMaterial.h.

## ◆ has_spec

bool EggMaterial::has_spec
| inline

Definition at line 96 of file eggMaterial.h.

## ◆ set_amb

void EggMaterial::set_amb
| inline

Definition at line 94 of file eggMaterial.h.

## ◆ set_base

void EggMaterial::set_base
| inline

Since
  1.10.0

Definition at line 92 of file eggMaterial.h.

## ◆ set_diff

void EggMaterial::set_diff
| inline

Definition at line 93 of file eggMaterial.h.

## ◆ set_emit

void EggMaterial::set_emit
| inline

Definition at line 95 of file eggMaterial.h.

## ◆ set_ior

void EggMaterial::set_ior
| inline

Since
  1.10.0

Definition at line 100 of file eggMaterial.h.

## ◆ set_local

void EggMaterial::set_local
| inline

Definition at line 102 of file eggMaterial.h.

## ◆ set_metallic

void EggMaterial::set_metallic
| inline

Since
  1.10.0

Definition at line 99 of file eggMaterial.h.

## ◆ set_roughness

void EggMaterial::set_roughness
| inline

Since
  1.10.0

Definition at line 98 of file eggMaterial.h.

## ◆ set_shininess

void EggMaterial::set_shininess
| inline

Definition at line 97 of file eggMaterial.h.

## ◆ set_spec

void EggMaterial::set_spec
| inline

Definition at line 96 of file eggMaterial.h.

The documentation for this class was generated from the following files:

- panda/src/egg/eggMaterial.h
- panda/src/egg/eggMaterial.cxx
- panda/src/egg/eggMaterial.I